// EFileBrowser	 (C)opyright 2006 Jonas Jarvoll
//
// This is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#ifndef __FOLDERTREEVIEW_H__
#define __FOLDERTREEVIEW_H__

#include <gui/treeview.h>
#include <gui/rect.h>
#include <util/string.h>
#include <util/message.h>

class FolderTreeView : public os::TreeView
{
public:
	FolderTreeView( const os::Rect& cFrame, const os::String& cPath, uint32 nResizeMask = os::CF_FOLLOW_LEFT | os::CF_FOLLOW_TOP );
	~FolderTreeView();

	void ReRead();
    void SetPath( const os::String& cPath );
    os::String GetPath() const;


	virtual void HandleMessage( os::Message* pcMessage );
	virtual void AttachedToWindow();
	virtual void DetachedFromWindow();
void FolderTreeView::AllAttached();
	
protected:
	enum { MSG_EXPAND };

	enum { M_ADD_ENTRY, M_UPDATE_ENTRY, M_REMOVE_ENTRY, M_LAYOUT, M_REREAD, M_MOUNT = 100, M_UNMOUNT, M_NEW_DIR, M_DELETE, M_RENAME, M_OPEN_WITH, M_INFO, M_MOVE_TO_TRASH, M_EMPTY_TRASH, M_JOB_END, M_JOB_END_REREAD };

private:
	void ReadDirectory( const os::String& path );
	void ReadRoot();
	bool FindSubDir( os::String path );
	void DisplayPath( int row, os::TreeViewNode* parent, os::String path );
	void ExpandItem( int row, os::TreeViewNode* parent );
	void CollapseItem( int row, os::TreeViewNode* parent );

    class Private;
    Private* m;
};

#endif

